default	rel
%define XMMWORD
section	.text code align=64

EXTERN	OPENSSL_ia32cap_P

global	aesni_cbc_sha1_enc

ALIGN	16
aesni_cbc_sha1_enc:

	mov	r10d,DWORD[((OPENSSL_ia32cap_P+0))]
	mov	r11d,DWORD[((OPENSSL_ia32cap_P+4))]
	and	r11d,268435456
	and	r10d,1073741824
	or	r10d,r11d
	cmp	r10d,1342177280
	je	NEAR aesni_cbc_sha1_enc_avx
	jmp	NEAR aesni_cbc_sha1_enc_ssse3
	DB	0F3h,0C3h		;repret


ALIGN	16
aesni_cbc_sha1_enc_ssse3:
	mov	QWORD[8+rsp],rdi	;WIN64 prologue
	mov	QWORD[16+rsp],rsi
	mov	rax,rsp
$L$SEH_begin_aesni_cbc_sha1_enc_ssse3:
	mov	rdi,rcx
	mov	rsi,rdx
	mov	rdx,r8
	mov	rcx,r9
	mov	r8,QWORD[40+rsp]
	mov	r9,QWORD[48+rsp]


	mov	r10,QWORD[56+rsp]


	push	rbx
	push	rbp
	push	r12
	push	r13
	push	r14
	push	r15
	lea	rsp,[((-264))+rsp]


	movaps	XMMWORD[(96+0)+rsp],xmm6
	movaps	XMMWORD[(96+16)+rsp],xmm7
	movaps	XMMWORD[(96+32)+rsp],xmm8
	movaps	XMMWORD[(96+48)+rsp],xmm9
	movaps	XMMWORD[(96+64)+rsp],xmm10
	movaps	XMMWORD[(96+80)+rsp],xmm11
	movaps	XMMWORD[(96+96)+rsp],xmm12
	movaps	XMMWORD[(96+112)+rsp],xmm13
	movaps	XMMWORD[(96+128)+rsp],xmm14
	movaps	XMMWORD[(96+144)+rsp],xmm15
$L$prologue_ssse3:
	mov	r12,rdi
	mov	r13,rsi
	mov	r14,rdx
	mov	r15,rcx
	movdqu	xmm11,XMMWORD[r8]
	mov	QWORD[88+rsp],r8
	shl	r14,6
	sub	r13,r12
	mov	r8d,DWORD[240+r15]
	add	r14,r10

	lea	r11,[K_XX_XX]
	mov	eax,DWORD[r9]
	mov	ebx,DWORD[4+r9]
	mov	ecx,DWORD[8+r9]
	mov	edx,DWORD[12+r9]
	mov	esi,ebx
	mov	ebp,DWORD[16+r9]

	movdqa	xmm6,XMMWORD[64+r11]
	movdqa	xmm9,XMMWORD[r11]
	movdqu	xmm0,XMMWORD[r10]
	movdqu	xmm1,XMMWORD[16+r10]
	movdqu	xmm2,XMMWORD[32+r10]
	movdqu	xmm3,XMMWORD[48+r10]
DB	102,15,56,0,198
	add	r10,64
DB	102,15,56,0,206
DB	102,15,56,0,214
DB	102,15,56,0,222
	paddd	xmm0,xmm9
	paddd	xmm1,xmm9
	paddd	xmm2,xmm9
	movdqa	XMMWORD[rsp],xmm0
	psubd	xmm0,xmm9
	movdqa	XMMWORD[16+rsp],xmm1
	psubd	xmm1,xmm9
	movdqa	XMMWORD[32+rsp],xmm2
	psubd	xmm2,xmm9
	movups	xmm13,XMMWORD[r15]
	movups	xmm14,XMMWORD[16+r15]
	jmp	NEAR $L$oop_ssse3
ALIGN	16
$L$oop_ssse3:
	movdqa	xmm4,xmm1
	add	ebp,DWORD[rsp]
	movups	xmm12,XMMWORD[r12]
	xorps	xmm12,xmm13
	xorps	xmm11,xmm12
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[32+r15]
	xor	ecx,edx
	movdqa	xmm8,xmm3
DB	102,15,58,15,224,8
	mov	edi,eax
	rol	eax,5
	paddd	xmm9,xmm3
	and	esi,ecx
	xor	ecx,edx
	psrldq	xmm8,4
	xor	esi,edx
	add	ebp,eax
	pxor	xmm4,xmm0
	ror	ebx,2
	add	ebp,esi
	pxor	xmm8,xmm2
	add	edx,DWORD[4+rsp]
	xor	ebx,ecx
	mov	esi,ebp
	rol	ebp,5
	pxor	xmm4,xmm8
	and	edi,ebx
	xor	ebx,ecx
	movdqa	XMMWORD[48+rsp],xmm9
	xor	edi,ecx
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[48+r15]
	add	edx,ebp
	movdqa	xmm10,xmm4
	movdqa	xmm8,xmm4
	ror	eax,7
	add	edx,edi
	add	ecx,DWORD[8+rsp]
	xor	eax,ebx
	pslldq	xmm10,12
	paddd	xmm4,xmm4
	mov	edi,edx
	rol	edx,5
	and	esi,eax
	xor	eax,ebx
	psrld	xmm8,31
	xor	esi,ebx
	add	ecx,edx
	movdqa	xmm9,xmm10
	ror	ebp,7
	add	ecx,esi
	psrld	xmm10,30
	por	xmm4,xmm8
	add	ebx,DWORD[12+rsp]
	xor	ebp,eax
	mov	esi,ecx
	rol	ecx,5
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[64+r15]
	pslld	xmm9,2
	pxor	xmm4,xmm10
	and	edi,ebp
	xor	ebp,eax
	movdqa	xmm10,XMMWORD[r11]
	xor	edi,eax
	add	ebx,ecx
	pxor	xmm4,xmm9
	ror	edx,7
	add	ebx,edi
	movdqa	xmm5,xmm2
	add	eax,DWORD[16+rsp]
	xor	edx,ebp
	movdqa	xmm9,xmm4
DB	102,15,58,15,233,8
	mov	edi,ebx
	rol	ebx,5
	paddd	xmm10,xmm4
	and	esi,edx
	xor	edx,ebp
	psrldq	xmm9,4
	xor	esi,ebp
	add	eax,ebx
	pxor	xmm5,xmm1
	ror	ecx,7
	add	eax,esi
	pxor	xmm9,xmm3
	add	ebp,DWORD[20+rsp]
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[80+r15]
	xor	ecx,edx
	mov	esi,eax
	rol	eax,5
	pxor	xmm5,xmm9
	and	edi,ecx
	xor	ecx,edx
	movdqa	XMMWORD[rsp],xmm10
	xor	edi,edx
	add	ebp,eax
	movdqa	xmm8,xmm5
	movdqa	xmm9,xmm5
	ror	ebx,7
	add	ebp,edi
	add	edx,DWORD[24+rsp]
	xor	ebx,ecx
	pslldq	xmm8,12
	paddd	xmm5,xmm5
	mov	edi,ebp
	rol	ebp,5
	and	esi,ebx
	xor	ebx,ecx
	psrld	xmm9,31
	xor	esi,ecx
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[96+r15]
	add	edx,ebp
	movdqa	xmm10,xmm8
	ror	eax,7
	add	edx,esi
	psrld	xmm8,30
	por	xmm5,xmm9
	add	ecx,DWORD[28+rsp]
	xor	eax,ebx
	mov	esi,edx
	rol	edx,5
	pslld	xmm10,2
	pxor	xmm5,xmm8
	and	edi,eax
	xor	eax,ebx
	movdqa	xmm8,XMMWORD[16+r11]
	xor	edi,ebx
	add	ecx,edx
	pxor	xmm5,xmm10
	ror	ebp,7
	add	ecx,edi
	movdqa	xmm6,xmm3
	add	ebx,DWORD[32+rsp]
	xor	ebp,eax
	movdqa	xmm10,xmm5
DB	102,15,58,15,242,8
	mov	edi,ecx
	rol	ecx,5
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[112+r15]
	paddd	xmm8,xmm5
	and	esi,ebp
	xor	ebp,eax
	psrldq	xmm10,4
	xor	esi,eax
	add	ebx,ecx
	pxor	xmm6,xmm2
	ror	edx,7
	add	ebx,esi
	pxor	xmm10,xmm4
	add	eax,DWORD[36+rsp]
	xor	edx,ebp
	mov	esi,ebx
	rol	ebx,5
	pxor	xmm6,xmm10
	and	edi,edx
	xor	edx,ebp
	movdqa	XMMWORD[16+rsp],xmm8
	xor	edi,ebp
	add	eax,ebx
	movdqa	xmm9,xmm6
	movdqa	xmm10,xmm6
	ror	ecx,7
	add	eax,edi
	add	ebp,DWORD[40+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[128+r15]
	xor	ecx,edx
	pslldq	xmm9,12
	paddd	xmm6,xmm6
	mov	edi,eax
	rol	eax,5
	and	esi,ecx
	xor	ecx,edx
	psrld	xmm10,31
	xor	esi,edx
	add	ebp,eax
	movdqa	xmm8,xmm9
	ror	ebx,7
	add	ebp,esi
	psrld	xmm9,30
	por	xmm6,xmm10
	add	edx,DWORD[44+rsp]
	xor	ebx,ecx
	mov	esi,ebp
	rol	ebp,5
	pslld	xmm8,2
	pxor	xmm6,xmm9
	and	edi,ebx
	xor	ebx,ecx
	movdqa	xmm9,XMMWORD[16+r11]
	xor	edi,ecx
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[144+r15]
	add	edx,ebp
	pxor	xmm6,xmm8
	ror	eax,7
	add	edx,edi
	movdqa	xmm7,xmm4
	add	ecx,DWORD[48+rsp]
	xor	eax,ebx
	movdqa	xmm8,xmm6
DB	102,15,58,15,251,8
	mov	edi,edx
	rol	edx,5
	paddd	xmm9,xmm6
	and	esi,eax
	xor	eax,ebx
	psrldq	xmm8,4
	xor	esi,ebx
	add	ecx,edx
	pxor	xmm7,xmm3
	ror	ebp,7
	add	ecx,esi
	pxor	xmm8,xmm5
	add	ebx,DWORD[52+rsp]
	xor	ebp,eax
	mov	esi,ecx
	rol	ecx,5
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[160+r15]
	pxor	xmm7,xmm8
	and	edi,ebp
	xor	ebp,eax
	movdqa	XMMWORD[32+rsp],xmm9
	xor	edi,eax
	add	ebx,ecx
	movdqa	xmm10,xmm7
	movdqa	xmm8,xmm7
	ror	edx,7
	add	ebx,edi
	add	eax,DWORD[56+rsp]
	xor	edx,ebp
	pslldq	xmm10,12
	paddd	xmm7,xmm7
	mov	edi,ebx
	rol	ebx,5
	and	esi,edx
	xor	edx,ebp
	psrld	xmm8,31
	xor	esi,ebp
	add	eax,ebx
	movdqa	xmm9,xmm10
	ror	ecx,7
	add	eax,esi
	psrld	xmm10,30
	por	xmm7,xmm8
	add	ebp,DWORD[60+rsp]
	cmp	r8d,11
	jb	NEAR $L$aesenclast1
	movups	xmm14,XMMWORD[176+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[192+r15]
DB	102,69,15,56,220,222
	je	NEAR $L$aesenclast1
	movups	xmm14,XMMWORD[208+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[224+r15]
DB	102,69,15,56,220,222
$L$aesenclast1:
DB	102,69,15,56,221,223
	movups	xmm14,XMMWORD[16+r15]
	xor	ecx,edx
	mov	esi,eax
	rol	eax,5
	pslld	xmm9,2
	pxor	xmm7,xmm10
	and	edi,ecx
	xor	ecx,edx
	movdqa	xmm10,XMMWORD[16+r11]
	xor	edi,edx
	add	ebp,eax
	pxor	xmm7,xmm9
	ror	ebx,7
	add	ebp,edi
	movdqa	xmm9,xmm7
	add	edx,DWORD[rsp]
	pxor	xmm0,xmm4
DB	102,68,15,58,15,206,8
	xor	ebx,ecx
	mov	edi,ebp
	rol	ebp,5
	pxor	xmm0,xmm1
	and	esi,ebx
	xor	ebx,ecx
	movdqa	xmm8,xmm10
	paddd	xmm10,xmm7
	xor	esi,ecx
	movups	xmm12,XMMWORD[16+r12]
	xorps	xmm12,xmm13
	movups	XMMWORD[r12*1+r13],xmm11
	xorps	xmm11,xmm12
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[32+r15]
	add	edx,ebp
	pxor	xmm0,xmm9
	ror	eax,7
	add	edx,esi
	add	ecx,DWORD[4+rsp]
	xor	eax,ebx
	movdqa	xmm9,xmm0
	movdqa	XMMWORD[48+rsp],xmm10
	mov	esi,edx
	rol	edx,5
	and	edi,eax
	xor	eax,ebx
	pslld	xmm0,2
	xor	edi,ebx
	add	ecx,edx
	psrld	xmm9,30
	ror	ebp,7
	add	ecx,edi
	add	ebx,DWORD[8+rsp]
	xor	ebp,eax
	mov	edi,ecx
	rol	ecx,5
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[48+r15]
	por	xmm0,xmm9
	and	esi,ebp
	xor	ebp,eax
	movdqa	xmm10,xmm0
	xor	esi,eax
	add	ebx,ecx
	ror	edx,7
	add	ebx,esi
	add	eax,DWORD[12+rsp]
	xor	edx,ebp
	mov	esi,ebx
	rol	ebx,5
	and	edi,edx
	xor	edx,ebp
	xor	edi,ebp
	add	eax,ebx
	ror	ecx,7
	add	eax,edi
	add	ebp,DWORD[16+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[64+r15]
	pxor	xmm1,xmm5
DB	102,68,15,58,15,215,8
	xor	esi,edx
	mov	edi,eax
	rol	eax,5
	pxor	xmm1,xmm2
	xor	esi,ecx
	add	ebp,eax
	movdqa	xmm9,xmm8
	paddd	xmm8,xmm0
	ror	ebx,7
	add	ebp,esi
	pxor	xmm1,xmm10
	add	edx,DWORD[20+rsp]
	xor	edi,ecx
	mov	esi,ebp
	rol	ebp,5
	movdqa	xmm10,xmm1
	movdqa	XMMWORD[rsp],xmm8
	xor	edi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,edi
	pslld	xmm1,2
	add	ecx,DWORD[24+rsp]
	xor	esi,ebx
	psrld	xmm10,30
	mov	edi,edx
	rol	edx,5
	xor	esi,eax
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[80+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,esi
	por	xmm1,xmm10
	add	ebx,DWORD[28+rsp]
	xor	edi,eax
	movdqa	xmm8,xmm1
	mov	esi,ecx
	rol	ecx,5
	xor	edi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,edi
	add	eax,DWORD[32+rsp]
	pxor	xmm2,xmm6
DB	102,68,15,58,15,192,8
	xor	esi,ebp
	mov	edi,ebx
	rol	ebx,5
	pxor	xmm2,xmm3
	xor	esi,edx
	add	eax,ebx
	movdqa	xmm10,XMMWORD[32+r11]
	paddd	xmm9,xmm1
	ror	ecx,7
	add	eax,esi
	pxor	xmm2,xmm8
	add	ebp,DWORD[36+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[96+r15]
	xor	edi,edx
	mov	esi,eax
	rol	eax,5
	movdqa	xmm8,xmm2
	movdqa	XMMWORD[16+rsp],xmm9
	xor	edi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,edi
	pslld	xmm2,2
	add	edx,DWORD[40+rsp]
	xor	esi,ecx
	psrld	xmm8,30
	mov	edi,ebp
	rol	ebp,5
	xor	esi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,esi
	por	xmm2,xmm8
	add	ecx,DWORD[44+rsp]
	xor	edi,ebx
	movdqa	xmm9,xmm2
	mov	esi,edx
	rol	edx,5
	xor	edi,eax
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[112+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,edi
	add	ebx,DWORD[48+rsp]
	pxor	xmm3,xmm7
DB	102,68,15,58,15,201,8
	xor	esi,eax
	mov	edi,ecx
	rol	ecx,5
	pxor	xmm3,xmm4
	xor	esi,ebp
	add	ebx,ecx
	movdqa	xmm8,xmm10
	paddd	xmm10,xmm2
	ror	edx,7
	add	ebx,esi
	pxor	xmm3,xmm9
	add	eax,DWORD[52+rsp]
	xor	edi,ebp
	mov	esi,ebx
	rol	ebx,5
	movdqa	xmm9,xmm3
	movdqa	XMMWORD[32+rsp],xmm10
	xor	edi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,edi
	pslld	xmm3,2
	add	ebp,DWORD[56+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[128+r15]
	xor	esi,edx
	psrld	xmm9,30
	mov	edi,eax
	rol	eax,5
	xor	esi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,esi
	por	xmm3,xmm9
	add	edx,DWORD[60+rsp]
	xor	edi,ecx
	movdqa	xmm10,xmm3
	mov	esi,ebp
	rol	ebp,5
	xor	edi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,edi
	add	ecx,DWORD[rsp]
	pxor	xmm4,xmm0
DB	102,68,15,58,15,210,8
	xor	esi,ebx
	mov	edi,edx
	rol	edx,5
	pxor	xmm4,xmm5
	xor	esi,eax
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[144+r15]
	add	ecx,edx
	movdqa	xmm9,xmm8
	paddd	xmm8,xmm3
	ror	ebp,7
	add	ecx,esi
	pxor	xmm4,xmm10
	add	ebx,DWORD[4+rsp]
	xor	edi,eax
	mov	esi,ecx
	rol	ecx,5
	movdqa	xmm10,xmm4
	movdqa	XMMWORD[48+rsp],xmm8
	xor	edi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,edi
	pslld	xmm4,2
	add	eax,DWORD[8+rsp]
	xor	esi,ebp
	psrld	xmm10,30
	mov	edi,ebx
	rol	ebx,5
	xor	esi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,esi
	por	xmm4,xmm10
	add	ebp,DWORD[12+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[160+r15]
	xor	edi,edx
	movdqa	xmm8,xmm4
	mov	esi,eax
	rol	eax,5
	xor	edi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,edi
	add	edx,DWORD[16+rsp]
	pxor	xmm5,xmm1
DB	102,68,15,58,15,195,8
	xor	esi,ecx
	mov	edi,ebp
	rol	ebp,5
	pxor	xmm5,xmm6
	xor	esi,ebx
	add	edx,ebp
	movdqa	xmm10,xmm9
	paddd	xmm9,xmm4
	ror	eax,7
	add	edx,esi
	pxor	xmm5,xmm8
	add	ecx,DWORD[20+rsp]
	xor	edi,ebx
	mov	esi,edx
	rol	edx,5
	movdqa	xmm8,xmm5
	movdqa	XMMWORD[rsp],xmm9
	xor	edi,eax
	cmp	r8d,11
	jb	NEAR $L$aesenclast2
	movups	xmm14,XMMWORD[176+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[192+r15]
DB	102,69,15,56,220,222
	je	NEAR $L$aesenclast2
	movups	xmm14,XMMWORD[208+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[224+r15]
DB	102,69,15,56,220,222
$L$aesenclast2:
DB	102,69,15,56,221,223
	movups	xmm14,XMMWORD[16+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,edi
	pslld	xmm5,2
	add	ebx,DWORD[24+rsp]
	xor	esi,eax
	psrld	xmm8,30
	mov	edi,ecx
	rol	ecx,5
	xor	esi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,esi
	por	xmm5,xmm8
	add	eax,DWORD[28+rsp]
	xor	edi,ebp
	movdqa	xmm9,xmm5
	mov	esi,ebx
	rol	ebx,5
	xor	edi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,edi
	mov	edi,ecx
	movups	xmm12,XMMWORD[32+r12]
	xorps	xmm12,xmm13
	movups	XMMWORD[16+r12*1+r13],xmm11
	xorps	xmm11,xmm12
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[32+r15]
	pxor	xmm6,xmm2
DB	102,68,15,58,15,204,8
	xor	ecx,edx
	add	ebp,DWORD[32+rsp]
	and	edi,edx
	pxor	xmm6,xmm7
	and	esi,ecx
	ror	ebx,7
	movdqa	xmm8,xmm10
	paddd	xmm10,xmm5
	add	ebp,edi
	mov	edi,eax
	pxor	xmm6,xmm9
	rol	eax,5
	add	ebp,esi
	xor	ecx,edx
	add	ebp,eax
	movdqa	xmm9,xmm6
	movdqa	XMMWORD[16+rsp],xmm10
	mov	esi,ebx
	xor	ebx,ecx
	add	edx,DWORD[36+rsp]
	and	esi,ecx
	pslld	xmm6,2
	and	edi,ebx
	ror	eax,7
	psrld	xmm9,30
	add	edx,esi
	mov	esi,ebp
	rol	ebp,5
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[48+r15]
	add	edx,edi
	xor	ebx,ecx
	add	edx,ebp
	por	xmm6,xmm9
	mov	edi,eax
	xor	eax,ebx
	movdqa	xmm10,xmm6
	add	ecx,DWORD[40+rsp]
	and	edi,ebx
	and	esi,eax
	ror	ebp,7
	add	ecx,edi
	mov	edi,edx
	rol	edx,5
	add	ecx,esi
	xor	eax,ebx
	add	ecx,edx
	mov	esi,ebp
	xor	ebp,eax
	add	ebx,DWORD[44+rsp]
	and	esi,eax
	and	edi,ebp
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[64+r15]
	ror	edx,7
	add	ebx,esi
	mov	esi,ecx
	rol	ecx,5
	add	ebx,edi
	xor	ebp,eax
	add	ebx,ecx
	mov	edi,edx
	pxor	xmm7,xmm3
DB	102,68,15,58,15,213,8
	xor	edx,ebp
	add	eax,DWORD[48+rsp]
	and	edi,ebp
	pxor	xmm7,xmm0
	and	esi,edx
	ror	ecx,7
	movdqa	xmm9,XMMWORD[48+r11]
	paddd	xmm8,xmm6
	add	eax,edi
	mov	edi,ebx
	pxor	xmm7,xmm10
	rol	ebx,5
	add	eax,esi
	xor	edx,ebp
	add	eax,ebx
	movdqa	xmm10,xmm7
	movdqa	XMMWORD[32+rsp],xmm8
	mov	esi,ecx
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[80+r15]
	xor	ecx,edx
	add	ebp,DWORD[52+rsp]
	and	esi,edx
	pslld	xmm7,2
	and	edi,ecx
	ror	ebx,7
	psrld	xmm10,30
	add	ebp,esi
	mov	esi,eax
	rol	eax,5
	add	ebp,edi
	xor	ecx,edx
	add	ebp,eax
	por	xmm7,xmm10
	mov	edi,ebx
	xor	ebx,ecx
	movdqa	xmm8,xmm7
	add	edx,DWORD[56+rsp]
	and	edi,ecx
	and	esi,ebx
	ror	eax,7
	add	edx,edi
	mov	edi,ebp
	rol	ebp,5
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[96+r15]
	add	edx,esi
	xor	ebx,ecx
	add	edx,ebp
	mov	esi,eax
	xor	eax,ebx
	add	ecx,DWORD[60+rsp]
	and	esi,ebx
	and	edi,eax
	ror	ebp,7
	add	ecx,esi
	mov	esi,edx
	rol	edx,5
	add	ecx,edi
	xor	eax,ebx
	add	ecx,edx
	mov	edi,ebp
	pxor	xmm0,xmm4
DB	102,68,15,58,15,198,8
	xor	ebp,eax
	add	ebx,DWORD[rsp]
	and	edi,eax
	pxor	xmm0,xmm1
	and	esi,ebp
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[112+r15]
	ror	edx,7
	movdqa	xmm10,xmm9
	paddd	xmm9,xmm7
	add	ebx,edi
	mov	edi,ecx
	pxor	xmm0,xmm8
	rol	ecx,5
	add	ebx,esi
	xor	ebp,eax
	add	ebx,ecx
	movdqa	xmm8,xmm0
	movdqa	XMMWORD[48+rsp],xmm9
	mov	esi,edx
	xor	edx,ebp
	add	eax,DWORD[4+rsp]
	and	esi,ebp
	pslld	xmm0,2
	and	edi,edx
	ror	ecx,7
	psrld	xmm8,30
	add	eax,esi
	mov	esi,ebx
	rol	ebx,5
	add	eax,edi
	xor	edx,ebp
	add	eax,ebx
	por	xmm0,xmm8
	mov	edi,ecx
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[128+r15]
	xor	ecx,edx
	movdqa	xmm9,xmm0
	add	ebp,DWORD[8+rsp]
	and	edi,edx
	and	esi,ecx
	ror	ebx,7
	add	ebp,edi
	mov	edi,eax
	rol	eax,5
	add	ebp,esi
	xor	ecx,edx
	add	ebp,eax
	mov	esi,ebx
	xor	ebx,ecx
	add	edx,DWORD[12+rsp]
	and	esi,ecx
	and	edi,ebx
	ror	eax,7
	add	edx,esi
	mov	esi,ebp
	rol	ebp,5
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[144+r15]
	add	edx,edi
	xor	ebx,ecx
	add	edx,ebp
	mov	edi,eax
	pxor	xmm1,xmm5
DB	102,68,15,58,15,207,8
	xor	eax,ebx
	add	ecx,DWORD[16+rsp]
	and	edi,ebx
	pxor	xmm1,xmm2
	and	esi,eax
	ror	ebp,7
	movdqa	xmm8,xmm10
	paddd	xmm10,xmm0
	add	ecx,edi
	mov	edi,edx
	pxor	xmm1,xmm9
	rol	edx,5
	add	ecx,esi
	xor	eax,ebx
	add	ecx,edx
	movdqa	xmm9,xmm1
	movdqa	XMMWORD[rsp],xmm10
	mov	esi,ebp
	xor	ebp,eax
	add	ebx,DWORD[20+rsp]
	and	esi,eax
	pslld	xmm1,2
	and	edi,ebp
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[160+r15]
	ror	edx,7
	psrld	xmm9,30
	add	ebx,esi
	mov	esi,ecx
	rol	ecx,5
	add	ebx,edi
	xor	ebp,eax
	add	ebx,ecx
	por	xmm1,xmm9
	mov	edi,edx
	xor	edx,ebp
	movdqa	xmm10,xmm1
	add	eax,DWORD[24+rsp]
	and	edi,ebp
	and	esi,edx
	ror	ecx,7
	add	eax,edi
	mov	edi,ebx
	rol	ebx,5
	add	eax,esi
	xor	edx,ebp
	add	eax,ebx
	mov	esi,ecx
	cmp	r8d,11
	jb	NEAR $L$aesenclast3
	movups	xmm14,XMMWORD[176+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[192+r15]
DB	102,69,15,56,220,222
	je	NEAR $L$aesenclast3
	movups	xmm14,XMMWORD[208+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[224+r15]
DB	102,69,15,56,220,222
$L$aesenclast3:
DB	102,69,15,56,221,223
	movups	xmm14,XMMWORD[16+r15]
	xor	ecx,edx
	add	ebp,DWORD[28+rsp]
	and	esi,edx
	and	edi,ecx
	ror	ebx,7
	add	ebp,esi
	mov	esi,eax
	rol	eax,5
	add	ebp,edi
	xor	ecx,edx
	add	ebp,eax
	mov	edi,ebx
	pxor	xmm2,xmm6
DB	102,68,15,58,15,208,8
	xor	ebx,ecx
	add	edx,DWORD[32+rsp]
	and	edi,ecx
	pxor	xmm2,xmm3
	and	esi,ebx
	ror	eax,7
	movdqa	xmm9,xmm8
	paddd	xmm8,xmm1
	add	edx,edi
	mov	edi,ebp
	pxor	xmm2,xmm10
	rol	ebp,5
	movups	xmm12,XMMWORD[48+r12]
	xorps	xmm12,xmm13
	movups	XMMWORD[32+r12*1+r13],xmm11
	xorps	xmm11,xmm12
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[32+r15]
	add	edx,esi
	xor	ebx,ecx
	add	edx,ebp
	movdqa	xmm10,xmm2
	movdqa	XMMWORD[16+rsp],xmm8
	mov	esi,eax
	xor	eax,ebx
	add	ecx,DWORD[36+rsp]
	and	esi,ebx
	pslld	xmm2,2
	and	edi,eax
	ror	ebp,7
	psrld	xmm10,30
	add	ecx,esi
	mov	esi,edx
	rol	edx,5
	add	ecx,edi
	xor	eax,ebx
	add	ecx,edx
	por	xmm2,xmm10
	mov	edi,ebp
	xor	ebp,eax
	movdqa	xmm8,xmm2
	add	ebx,DWORD[40+rsp]
	and	edi,eax
	and	esi,ebp
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[48+r15]
	ror	edx,7
	add	ebx,edi
	mov	edi,ecx
	rol	ecx,5
	add	ebx,esi
	xor	ebp,eax
	add	ebx,ecx
	mov	esi,edx
	xor	edx,ebp
	add	eax,DWORD[44+rsp]
	and	esi,ebp
	and	edi,edx
	ror	ecx,7
	add	eax,esi
	mov	esi,ebx
	rol	ebx,5
	add	eax,edi
	xor	edx,ebp
	add	eax,ebx
	add	ebp,DWORD[48+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[64+r15]
	pxor	xmm3,xmm7
DB	102,68,15,58,15,193,8
	xor	esi,edx
	mov	edi,eax
	rol	eax,5
	pxor	xmm3,xmm4
	xor	esi,ecx
	add	ebp,eax
	movdqa	xmm10,xmm9
	paddd	xmm9,xmm2
	ror	ebx,7
	add	ebp,esi
	pxor	xmm3,xmm8
	add	edx,DWORD[52+rsp]
	xor	edi,ecx
	mov	esi,ebp
	rol	ebp,5
	movdqa	xmm8,xmm3
	movdqa	XMMWORD[32+rsp],xmm9
	xor	edi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,edi
	pslld	xmm3,2
	add	ecx,DWORD[56+rsp]
	xor	esi,ebx
	psrld	xmm8,30
	mov	edi,edx
	rol	edx,5
	xor	esi,eax
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[80+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,esi
	por	xmm3,xmm8
	add	ebx,DWORD[60+rsp]
	xor	edi,eax
	mov	esi,ecx
	rol	ecx,5
	xor	edi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,edi
	add	eax,DWORD[rsp]
	paddd	xmm10,xmm3
	xor	esi,ebp
	mov	edi,ebx
	rol	ebx,5
	xor	esi,edx
	movdqa	XMMWORD[48+rsp],xmm10
	add	eax,ebx
	ror	ecx,7
	add	eax,esi
	add	ebp,DWORD[4+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[96+r15]
	xor	edi,edx
	mov	esi,eax
	rol	eax,5
	xor	edi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,edi
	add	edx,DWORD[8+rsp]
	xor	esi,ecx
	mov	edi,ebp
	rol	ebp,5
	xor	esi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,esi
	add	ecx,DWORD[12+rsp]
	xor	edi,ebx
	mov	esi,edx
	rol	edx,5
	xor	edi,eax
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[112+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,edi
	cmp	r10,r14
	je	NEAR $L$done_ssse3
	movdqa	xmm6,XMMWORD[64+r11]
	movdqa	xmm9,XMMWORD[r11]
	movdqu	xmm0,XMMWORD[r10]
	movdqu	xmm1,XMMWORD[16+r10]
	movdqu	xmm2,XMMWORD[32+r10]
	movdqu	xmm3,XMMWORD[48+r10]
DB	102,15,56,0,198
	add	r10,64
	add	ebx,DWORD[16+rsp]
	xor	esi,eax
DB	102,15,56,0,206
	mov	edi,ecx
	rol	ecx,5
	paddd	xmm0,xmm9
	xor	esi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,esi
	movdqa	XMMWORD[rsp],xmm0
	add	eax,DWORD[20+rsp]
	xor	edi,ebp
	psubd	xmm0,xmm9
	mov	esi,ebx
	rol	ebx,5
	xor	edi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,edi
	add	ebp,DWORD[24+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[128+r15]
	xor	esi,edx
	mov	edi,eax
	rol	eax,5
	xor	esi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,esi
	add	edx,DWORD[28+rsp]
	xor	edi,ecx
	mov	esi,ebp
	rol	ebp,5
	xor	edi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,edi
	add	ecx,DWORD[32+rsp]
	xor	esi,ebx
DB	102,15,56,0,214
	mov	edi,edx
	rol	edx,5
	paddd	xmm1,xmm9
	xor	esi,eax
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[144+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,esi
	movdqa	XMMWORD[16+rsp],xmm1
	add	ebx,DWORD[36+rsp]
	xor	edi,eax
	psubd	xmm1,xmm9
	mov	esi,ecx
	rol	ecx,5
	xor	edi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,edi
	add	eax,DWORD[40+rsp]
	xor	esi,ebp
	mov	edi,ebx
	rol	ebx,5
	xor	esi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,esi
	add	ebp,DWORD[44+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[160+r15]
	xor	edi,edx
	mov	esi,eax
	rol	eax,5
	xor	edi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,edi
	add	edx,DWORD[48+rsp]
	xor	esi,ecx
DB	102,15,56,0,222
	mov	edi,ebp
	rol	ebp,5
	paddd	xmm2,xmm9
	xor	esi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,esi
	movdqa	XMMWORD[32+rsp],xmm2
	add	ecx,DWORD[52+rsp]
	xor	edi,ebx
	psubd	xmm2,xmm9
	mov	esi,edx
	rol	edx,5
	xor	edi,eax
	cmp	r8d,11
	jb	NEAR $L$aesenclast4
	movups	xmm14,XMMWORD[176+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[192+r15]
DB	102,69,15,56,220,222
	je	NEAR $L$aesenclast4
	movups	xmm14,XMMWORD[208+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[224+r15]
DB	102,69,15,56,220,222
$L$aesenclast4:
DB	102,69,15,56,221,223
	movups	xmm14,XMMWORD[16+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,edi
	add	ebx,DWORD[56+rsp]
	xor	esi,eax
	mov	edi,ecx
	rol	ecx,5
	xor	esi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,esi
	add	eax,DWORD[60+rsp]
	xor	edi,ebp
	mov	esi,ebx
	rol	ebx,5
	xor	edi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,edi
	movups	XMMWORD[48+r12*1+r13],xmm11
	lea	r12,[64+r12]

	add	eax,DWORD[r9]
	add	esi,DWORD[4+r9]
	add	ecx,DWORD[8+r9]
	add	edx,DWORD[12+r9]
	mov	DWORD[r9],eax
	add	ebp,DWORD[16+r9]
	mov	DWORD[4+r9],esi
	mov	ebx,esi
	mov	DWORD[8+r9],ecx
	mov	DWORD[12+r9],edx
	mov	DWORD[16+r9],ebp
	jmp	NEAR $L$oop_ssse3

ALIGN	16
$L$done_ssse3:
	add	ebx,DWORD[16+rsp]
	xor	esi,eax
	mov	edi,ecx
	rol	ecx,5
	xor	esi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,esi
	add	eax,DWORD[20+rsp]
	xor	edi,ebp
	mov	esi,ebx
	rol	ebx,5
	xor	edi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,edi
	add	ebp,DWORD[24+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[128+r15]
	xor	esi,edx
	mov	edi,eax
	rol	eax,5
	xor	esi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,esi
	add	edx,DWORD[28+rsp]
	xor	edi,ecx
	mov	esi,ebp
	rol	ebp,5
	xor	edi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,edi
	add	ecx,DWORD[32+rsp]
	xor	esi,ebx
	mov	edi,edx
	rol	edx,5
	xor	esi,eax
DB	102,69,15,56,220,223
	movups	xmm14,XMMWORD[144+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,esi
	add	ebx,DWORD[36+rsp]
	xor	edi,eax
	mov	esi,ecx
	rol	ecx,5
	xor	edi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,edi
	add	eax,DWORD[40+rsp]
	xor	esi,ebp
	mov	edi,ebx
	rol	ebx,5
	xor	esi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,esi
	add	ebp,DWORD[44+rsp]
DB	102,69,15,56,220,222
	movups	xmm15,XMMWORD[160+r15]
	xor	edi,edx
	mov	esi,eax
	rol	eax,5
	xor	edi,ecx
	add	ebp,eax
	ror	ebx,7
	add	ebp,edi
	add	edx,DWORD[48+rsp]
	xor	esi,ecx
	mov	edi,ebp
	rol	ebp,5
	xor	esi,ebx
	add	edx,ebp
	ror	eax,7
	add	edx,esi
	add	ecx,DWORD[52+rsp]
	xor	edi,ebx
	mov	esi,edx
	rol	edx,5
	xor	edi,eax
	cmp	r8d,11
	jb	NEAR $L$aesenclast5
	movups	xmm14,XMMWORD[176+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[192+r15]
DB	102,69,15,56,220,222
	je	NEAR $L$aesenclast5
	movups	xmm14,XMMWORD[208+r15]
DB	102,69,15,56,220,223
	movups	xmm15,XMMWORD[224+r15]
DB	102,69,15,56,220,222
$L$aesenclast5:
DB	102,69,15,56,221,223
	movups	xmm14,XMMWORD[16+r15]
	add	ecx,edx
	ror	ebp,7
	add	ecx,edi
	add	ebx,DWORD[56+rsp]
	xor	esi,eax
	mov	edi,ecx
	rol	ecx,5
	xor	esi,ebp
	add	ebx,ecx
	ror	edx,7
	add	ebx,esi
	add	eax,DWORD[60+rsp]
	xor	edi,ebp
	mov	esi,ebx
	rol	ebx,5
	xor	edi,edx
	add	eax,ebx
	ror	ecx,7
	add	eax,edi
	movups	XMMWORD[48+r12*1+r13],xmm11
	mov	r8,QWORD[88+rsp]

	add	eax,DWORD[r9]
	add	esi,DWORD[4+r9]
	add	ecx,DWORD[8+r9]
	mov	DWORD[r9],eax
	add	edx,DWORD[12+r9]
	mov	DWORD[4+r9],esi
	add	ebp,DWORD[16+r9]
	mov	DWORD[8+r9],ecx
	mov	DWORD[12+r9],edx
	mov	DWORD[16+r9],ebp
	movups	XMMWORD[r8],xmm11
	movaps	xmm6,XMMWORD[((96+0))+rsp]
	movaps	xmm7,XMMWORD[((96+16))+rsp]
	movaps	xmm8,XMMWORD[((96+32))+rsp]
	movaps	xmm9,XMMWORD[((96+48))+rsp]
	movaps	xmm10,XMMWORD[((96+64))+rsp]
	movaps	xmm11,XMMWORD[((96+80))+rsp]
	movaps	xmm12,XMMWORD[((96+96))+rsp]
	movaps	xmm13,XMMWORD[((96+112))+rsp]
	movaps	xmm14,XMMWORD[((96+128))+rsp]
	movaps	xmm15,XMMWORD[((96+144))+rsp]
	lea	rsi,[264+rsp]
	mov	r15,QWORD[rsi]
	mov	r14,QWORD[8+rsi]
	mov	r13,QWORD[16+rsi]
	mov	r12,QWORD[24+rsi]
	mov	rbp,QWORD[32+rsi]
	mov	rbx,QWORD[40+rsi]
	lea	rsp,[48+rsi]
$L$epilogue_ssse3:
	mov	rdi,QWORD[8+rsp]	;WIN64 epilogue
	mov	rsi,QWORD[16+rsp]
	DB	0F3h,0C3h		;repret
$L$SEH_end_aesni_cbc_sha1_enc_ssse3:

ALIGN	16
aesni_cbc_sha1_enc_avx:
	mov	QWORD[8+rsp],rdi	;WIN64 prologue
	mov	QWORD[16+rsp],rsi
	mov	rax,rsp
$L$SEH_begin_aesni_cbc_sha1_enc_avx:
	mov	rdi,rcx
	mov	rsi,rdx
	mov	rdx,r8
	mov	rcx,r9
	mov	r8,QWORD[40+rsp]
	mov	r9,QWORD[48+rsp]


	mov	r10,QWORD[56+rsp]


	push	rbx
	push	rbp
	push	r12
	push	r13
	push	r14
	push	r15
	lea	rsp,[((-264))+rsp]


	movaps	XMMWORD[(96+0)+rsp],xmm6
	movaps	XMMWORD[(96+16)+rsp],xmm7
	movaps	XMMWORD[(96+32)+rsp],xmm8
	movaps	XMMWORD[(96+48)+rsp],xmm9
	movaps	XMMWORD[(96+64)+rsp],xmm10
	movaps	XMMWORD[(96+80)+rsp],xmm11
	movaps	XMMWORD[(96+96)+rsp],xmm12
	movaps	XMMWORD[(96+112)+rsp],xmm13
	movaps	XMMWORD[(96+128)+rsp],xmm14
	movaps	XMMWORD[(96+144)+rsp],xmm15
$L$prologue_avx:
	vzeroall
	mov	r12,rdi
	mov	r13,rsi
	mov	r14,rdx
	mov	r15,rcx
	vmovdqu	xmm11,XMMWORD[r8]
	mov	QWORD[88+rsp],r8
	shl	r14,6
	sub	r13,r12
	mov	r8d,DWORD[240+r15]
	add	r15,112
	add	r14,r10

	lea	r11,[K_XX_XX]
	mov	eax,DWORD[r9]
	mov	ebx,DWORD[4+r9]
	mov	ecx,DWORD[8+r9]
	mov	edx,DWORD[12+r9]
	mov	esi,ebx
	mov	ebp,DWORD[16+r9]

	vmovdqa	xmm6,XMMWORD[64+r11]
	vmovdqa	xmm9,XMMWORD[r11]
	vmovdqu	xmm0,XMMWORD[r10]
	vmovdqu	xmm1,XMMWORD[16+r10]
	vmovdqu	xmm2,XMMWORD[32+r10]
	vmovdqu	xmm3,XMMWORD[48+r10]
	vpshufb	xmm0,xmm0,xmm6
	add	r10,64
	vpshufb	xmm1,xmm1,xmm6
	vpshufb	xmm2,xmm2,xmm6
	vpshufb	xmm3,xmm3,xmm6
	vpaddd	xmm4,xmm0,xmm9
	vpaddd	xmm5,xmm1,xmm9
	vpaddd	xmm6,xmm2,xmm9
	vmovdqa	XMMWORD[rsp],xmm4
	vmovdqa	XMMWORD[16+rsp],xmm5
	vmovdqa	XMMWORD[32+rsp],xmm6
	vmovups	xmm13,XMMWORD[((-112))+r15]
	vmovups	xmm14,XMMWORD[((16-112))+r15]
	jmp	NEAR $L$oop_avx
ALIGN	16
$L$oop_avx:
	add	ebp,DWORD[rsp]
	vmovups	xmm12,XMMWORD[r12]
	vxorps	xmm12,xmm12,xmm13
	vxorps	xmm11,xmm11,xmm12
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-80))+r15]
	xor	ecx,edx
	vpalignr	xmm4,xmm1,xmm0,8
	mov	edi,eax
	shld	eax,eax,5
	vpaddd	xmm9,xmm9,xmm3
	and	esi,ecx
	xor	ecx,edx
	vpsrldq	xmm8,xmm3,4
	xor	esi,edx
	add	ebp,eax
	vpxor	xmm4,xmm4,xmm0
	shrd	ebx,ebx,2
	add	ebp,esi
	vpxor	xmm8,xmm8,xmm2
	add	edx,DWORD[4+rsp]
	xor	ebx,ecx
	mov	esi,ebp
	shld	ebp,ebp,5
	vpxor	xmm4,xmm4,xmm8
	and	edi,ebx
	xor	ebx,ecx
	vmovdqa	XMMWORD[48+rsp],xmm9
	xor	edi,ecx
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-64))+r15]
	add	edx,ebp
	vpsrld	xmm8,xmm4,31
	shrd	eax,eax,7
	add	edx,edi
	add	ecx,DWORD[8+rsp]
	xor	eax,ebx
	vpslldq	xmm10,xmm4,12
	vpaddd	xmm4,xmm4,xmm4
	mov	edi,edx
	shld	edx,edx,5
	and	esi,eax
	xor	eax,ebx
	vpsrld	xmm9,xmm10,30
	vpor	xmm4,xmm4,xmm8
	xor	esi,ebx
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,esi
	vpslld	xmm10,xmm10,2
	vpxor	xmm4,xmm4,xmm9
	add	ebx,DWORD[12+rsp]
	xor	ebp,eax
	mov	esi,ecx
	shld	ecx,ecx,5
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-48))+r15]
	vpxor	xmm4,xmm4,xmm10
	and	edi,ebp
	xor	ebp,eax
	vmovdqa	xmm10,XMMWORD[r11]
	xor	edi,eax
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,edi
	add	eax,DWORD[16+rsp]
	xor	edx,ebp
	vpalignr	xmm5,xmm2,xmm1,8
	mov	edi,ebx
	shld	ebx,ebx,5
	vpaddd	xmm10,xmm10,xmm4
	and	esi,edx
	xor	edx,ebp
	vpsrldq	xmm9,xmm4,4
	xor	esi,ebp
	add	eax,ebx
	vpxor	xmm5,xmm5,xmm1
	shrd	ecx,ecx,7
	add	eax,esi
	vpxor	xmm9,xmm9,xmm3
	add	ebp,DWORD[20+rsp]
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-32))+r15]
	xor	ecx,edx
	mov	esi,eax
	shld	eax,eax,5
	vpxor	xmm5,xmm5,xmm9
	and	edi,ecx
	xor	ecx,edx
	vmovdqa	XMMWORD[rsp],xmm10
	xor	edi,edx
	add	ebp,eax
	vpsrld	xmm9,xmm5,31
	shrd	ebx,ebx,7
	add	ebp,edi
	add	edx,DWORD[24+rsp]
	xor	ebx,ecx
	vpslldq	xmm8,xmm5,12
	vpaddd	xmm5,xmm5,xmm5
	mov	edi,ebp
	shld	ebp,ebp,5
	and	esi,ebx
	xor	ebx,ecx
	vpsrld	xmm10,xmm8,30
	vpor	xmm5,xmm5,xmm9
	xor	esi,ecx
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-16))+r15]
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,esi
	vpslld	xmm8,xmm8,2
	vpxor	xmm5,xmm5,xmm10
	add	ecx,DWORD[28+rsp]
	xor	eax,ebx
	mov	esi,edx
	shld	edx,edx,5
	vpxor	xmm5,xmm5,xmm8
	and	edi,eax
	xor	eax,ebx
	vmovdqa	xmm8,XMMWORD[16+r11]
	xor	edi,ebx
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,edi
	add	ebx,DWORD[32+rsp]
	xor	ebp,eax
	vpalignr	xmm6,xmm3,xmm2,8
	mov	edi,ecx
	shld	ecx,ecx,5
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[r15]
	vpaddd	xmm8,xmm8,xmm5
	and	esi,ebp
	xor	ebp,eax
	vpsrldq	xmm10,xmm5,4
	xor	esi,eax
	add	ebx,ecx
	vpxor	xmm6,xmm6,xmm2
	shrd	edx,edx,7
	add	ebx,esi
	vpxor	xmm10,xmm10,xmm4
	add	eax,DWORD[36+rsp]
	xor	edx,ebp
	mov	esi,ebx
	shld	ebx,ebx,5
	vpxor	xmm6,xmm6,xmm10
	and	edi,edx
	xor	edx,ebp
	vmovdqa	XMMWORD[16+rsp],xmm8
	xor	edi,ebp
	add	eax,ebx
	vpsrld	xmm10,xmm6,31
	shrd	ecx,ecx,7
	add	eax,edi
	add	ebp,DWORD[40+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[16+r15]
	xor	ecx,edx
	vpslldq	xmm9,xmm6,12
	vpaddd	xmm6,xmm6,xmm6
	mov	edi,eax
	shld	eax,eax,5
	and	esi,ecx
	xor	ecx,edx
	vpsrld	xmm8,xmm9,30
	vpor	xmm6,xmm6,xmm10
	xor	esi,edx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,esi
	vpslld	xmm9,xmm9,2
	vpxor	xmm6,xmm6,xmm8
	add	edx,DWORD[44+rsp]
	xor	ebx,ecx
	mov	esi,ebp
	shld	ebp,ebp,5
	vpxor	xmm6,xmm6,xmm9
	and	edi,ebx
	xor	ebx,ecx
	vmovdqa	xmm9,XMMWORD[16+r11]
	xor	edi,ecx
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[32+r15]
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,edi
	add	ecx,DWORD[48+rsp]
	xor	eax,ebx
	vpalignr	xmm7,xmm4,xmm3,8
	mov	edi,edx
	shld	edx,edx,5
	vpaddd	xmm9,xmm9,xmm6
	and	esi,eax
	xor	eax,ebx
	vpsrldq	xmm8,xmm6,4
	xor	esi,ebx
	add	ecx,edx
	vpxor	xmm7,xmm7,xmm3
	shrd	ebp,ebp,7
	add	ecx,esi
	vpxor	xmm8,xmm8,xmm5
	add	ebx,DWORD[52+rsp]
	xor	ebp,eax
	mov	esi,ecx
	shld	ecx,ecx,5
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[48+r15]
	vpxor	xmm7,xmm7,xmm8
	and	edi,ebp
	xor	ebp,eax
	vmovdqa	XMMWORD[32+rsp],xmm9
	xor	edi,eax
	add	ebx,ecx
	vpsrld	xmm8,xmm7,31
	shrd	edx,edx,7
	add	ebx,edi
	add	eax,DWORD[56+rsp]
	xor	edx,ebp
	vpslldq	xmm10,xmm7,12
	vpaddd	xmm7,xmm7,xmm7
	mov	edi,ebx
	shld	ebx,ebx,5
	and	esi,edx
	xor	edx,ebp
	vpsrld	xmm9,xmm10,30
	vpor	xmm7,xmm7,xmm8
	xor	esi,ebp
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,esi
	vpslld	xmm10,xmm10,2
	vpxor	xmm7,xmm7,xmm9
	add	ebp,DWORD[60+rsp]
	cmp	r8d,11
	jb	NEAR $L$vaesenclast1
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[64+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[80+r15]
	je	NEAR $L$vaesenclast1
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[96+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[112+r15]
$L$vaesenclast1:
	vaesenclast	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((16-112))+r15]
	xor	ecx,edx
	mov	esi,eax
	shld	eax,eax,5
	vpxor	xmm7,xmm7,xmm10
	and	edi,ecx
	xor	ecx,edx
	vmovdqa	xmm10,XMMWORD[16+r11]
	xor	edi,edx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,edi
	vpalignr	xmm9,xmm7,xmm6,8
	vpxor	xmm0,xmm0,xmm4
	add	edx,DWORD[rsp]
	xor	ebx,ecx
	mov	edi,ebp
	shld	ebp,ebp,5
	vpxor	xmm0,xmm0,xmm1
	and	esi,ebx
	xor	ebx,ecx
	vmovdqa	xmm8,xmm10
	vpaddd	xmm10,xmm10,xmm7
	xor	esi,ecx
	vmovups	xmm12,XMMWORD[16+r12]
	vxorps	xmm12,xmm12,xmm13
	vmovups	XMMWORD[r12*1+r13],xmm11
	vxorps	xmm11,xmm11,xmm12
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-80))+r15]
	add	edx,ebp
	vpxor	xmm0,xmm0,xmm9
	shrd	eax,eax,7
	add	edx,esi
	add	ecx,DWORD[4+rsp]
	xor	eax,ebx
	vpsrld	xmm9,xmm0,30
	vmovdqa	XMMWORD[48+rsp],xmm10
	mov	esi,edx
	shld	edx,edx,5
	and	edi,eax
	xor	eax,ebx
	vpslld	xmm0,xmm0,2
	xor	edi,ebx
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,edi
	add	ebx,DWORD[8+rsp]
	xor	ebp,eax
	mov	edi,ecx
	shld	ecx,ecx,5
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-64))+r15]
	vpor	xmm0,xmm0,xmm9
	and	esi,ebp
	xor	ebp,eax
	vmovdqa	xmm10,xmm0
	xor	esi,eax
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,esi
	add	eax,DWORD[12+rsp]
	xor	edx,ebp
	mov	esi,ebx
	shld	ebx,ebx,5
	and	edi,edx
	xor	edx,ebp
	xor	edi,ebp
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,edi
	vpalignr	xmm10,xmm0,xmm7,8
	vpxor	xmm1,xmm1,xmm5
	add	ebp,DWORD[16+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-48))+r15]
	xor	esi,edx
	mov	edi,eax
	shld	eax,eax,5
	vpxor	xmm1,xmm1,xmm2
	xor	esi,ecx
	add	ebp,eax
	vmovdqa	xmm9,xmm8
	vpaddd	xmm8,xmm8,xmm0
	shrd	ebx,ebx,7
	add	ebp,esi
	vpxor	xmm1,xmm1,xmm10
	add	edx,DWORD[20+rsp]
	xor	edi,ecx
	mov	esi,ebp
	shld	ebp,ebp,5
	vpsrld	xmm10,xmm1,30
	vmovdqa	XMMWORD[rsp],xmm8
	xor	edi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,edi
	vpslld	xmm1,xmm1,2
	add	ecx,DWORD[24+rsp]
	xor	esi,ebx
	mov	edi,edx
	shld	edx,edx,5
	xor	esi,eax
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-32))+r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,esi
	vpor	xmm1,xmm1,xmm10
	add	ebx,DWORD[28+rsp]
	xor	edi,eax
	vmovdqa	xmm8,xmm1
	mov	esi,ecx
	shld	ecx,ecx,5
	xor	edi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,edi
	vpalignr	xmm8,xmm1,xmm0,8
	vpxor	xmm2,xmm2,xmm6
	add	eax,DWORD[32+rsp]
	xor	esi,ebp
	mov	edi,ebx
	shld	ebx,ebx,5
	vpxor	xmm2,xmm2,xmm3
	xor	esi,edx
	add	eax,ebx
	vmovdqa	xmm10,XMMWORD[32+r11]
	vpaddd	xmm9,xmm9,xmm1
	shrd	ecx,ecx,7
	add	eax,esi
	vpxor	xmm2,xmm2,xmm8
	add	ebp,DWORD[36+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-16))+r15]
	xor	edi,edx
	mov	esi,eax
	shld	eax,eax,5
	vpsrld	xmm8,xmm2,30
	vmovdqa	XMMWORD[16+rsp],xmm9
	xor	edi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,edi
	vpslld	xmm2,xmm2,2
	add	edx,DWORD[40+rsp]
	xor	esi,ecx
	mov	edi,ebp
	shld	ebp,ebp,5
	xor	esi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,esi
	vpor	xmm2,xmm2,xmm8
	add	ecx,DWORD[44+rsp]
	xor	edi,ebx
	vmovdqa	xmm9,xmm2
	mov	esi,edx
	shld	edx,edx,5
	xor	edi,eax
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,edi
	vpalignr	xmm9,xmm2,xmm1,8
	vpxor	xmm3,xmm3,xmm7
	add	ebx,DWORD[48+rsp]
	xor	esi,eax
	mov	edi,ecx
	shld	ecx,ecx,5
	vpxor	xmm3,xmm3,xmm4
	xor	esi,ebp
	add	ebx,ecx
	vmovdqa	xmm8,xmm10
	vpaddd	xmm10,xmm10,xmm2
	shrd	edx,edx,7
	add	ebx,esi
	vpxor	xmm3,xmm3,xmm9
	add	eax,DWORD[52+rsp]
	xor	edi,ebp
	mov	esi,ebx
	shld	ebx,ebx,5
	vpsrld	xmm9,xmm3,30
	vmovdqa	XMMWORD[32+rsp],xmm10
	xor	edi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,edi
	vpslld	xmm3,xmm3,2
	add	ebp,DWORD[56+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[16+r15]
	xor	esi,edx
	mov	edi,eax
	shld	eax,eax,5
	xor	esi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,esi
	vpor	xmm3,xmm3,xmm9
	add	edx,DWORD[60+rsp]
	xor	edi,ecx
	vmovdqa	xmm10,xmm3
	mov	esi,ebp
	shld	ebp,ebp,5
	xor	edi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,edi
	vpalignr	xmm10,xmm3,xmm2,8
	vpxor	xmm4,xmm4,xmm0
	add	ecx,DWORD[rsp]
	xor	esi,ebx
	mov	edi,edx
	shld	edx,edx,5
	vpxor	xmm4,xmm4,xmm5
	xor	esi,eax
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[32+r15]
	add	ecx,edx
	vmovdqa	xmm9,xmm8
	vpaddd	xmm8,xmm8,xmm3
	shrd	ebp,ebp,7
	add	ecx,esi
	vpxor	xmm4,xmm4,xmm10
	add	ebx,DWORD[4+rsp]
	xor	edi,eax
	mov	esi,ecx
	shld	ecx,ecx,5
	vpsrld	xmm10,xmm4,30
	vmovdqa	XMMWORD[48+rsp],xmm8
	xor	edi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,edi
	vpslld	xmm4,xmm4,2
	add	eax,DWORD[8+rsp]
	xor	esi,ebp
	mov	edi,ebx
	shld	ebx,ebx,5
	xor	esi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,esi
	vpor	xmm4,xmm4,xmm10
	add	ebp,DWORD[12+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[48+r15]
	xor	edi,edx
	vmovdqa	xmm8,xmm4
	mov	esi,eax
	shld	eax,eax,5
	xor	edi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,edi
	vpalignr	xmm8,xmm4,xmm3,8
	vpxor	xmm5,xmm5,xmm1
	add	edx,DWORD[16+rsp]
	xor	esi,ecx
	mov	edi,ebp
	shld	ebp,ebp,5
	vpxor	xmm5,xmm5,xmm6
	xor	esi,ebx
	add	edx,ebp
	vmovdqa	xmm10,xmm9
	vpaddd	xmm9,xmm9,xmm4
	shrd	eax,eax,7
	add	edx,esi
	vpxor	xmm5,xmm5,xmm8
	add	ecx,DWORD[20+rsp]
	xor	edi,ebx
	mov	esi,edx
	shld	edx,edx,5
	vpsrld	xmm8,xmm5,30
	vmovdqa	XMMWORD[rsp],xmm9
	xor	edi,eax
	cmp	r8d,11
	jb	NEAR $L$vaesenclast2
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[64+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[80+r15]
	je	NEAR $L$vaesenclast2
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[96+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[112+r15]
$L$vaesenclast2:
	vaesenclast	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((16-112))+r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,edi
	vpslld	xmm5,xmm5,2
	add	ebx,DWORD[24+rsp]
	xor	esi,eax
	mov	edi,ecx
	shld	ecx,ecx,5
	xor	esi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,esi
	vpor	xmm5,xmm5,xmm8
	add	eax,DWORD[28+rsp]
	xor	edi,ebp
	vmovdqa	xmm9,xmm5
	mov	esi,ebx
	shld	ebx,ebx,5
	xor	edi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,edi
	vpalignr	xmm9,xmm5,xmm4,8
	vpxor	xmm6,xmm6,xmm2
	mov	edi,ecx
	vmovups	xmm12,XMMWORD[32+r12]
	vxorps	xmm12,xmm12,xmm13
	vmovups	XMMWORD[16+r12*1+r13],xmm11
	vxorps	xmm11,xmm11,xmm12
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-80))+r15]
	xor	ecx,edx
	add	ebp,DWORD[32+rsp]
	and	edi,edx
	vpxor	xmm6,xmm6,xmm7
	and	esi,ecx
	shrd	ebx,ebx,7
	vmovdqa	xmm8,xmm10
	vpaddd	xmm10,xmm10,xmm5
	add	ebp,edi
	mov	edi,eax
	vpxor	xmm6,xmm6,xmm9
	shld	eax,eax,5
	add	ebp,esi
	xor	ecx,edx
	add	ebp,eax
	vpsrld	xmm9,xmm6,30
	vmovdqa	XMMWORD[16+rsp],xmm10
	mov	esi,ebx
	xor	ebx,ecx
	add	edx,DWORD[36+rsp]
	and	esi,ecx
	vpslld	xmm6,xmm6,2
	and	edi,ebx
	shrd	eax,eax,7
	add	edx,esi
	mov	esi,ebp
	shld	ebp,ebp,5
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-64))+r15]
	add	edx,edi
	xor	ebx,ecx
	add	edx,ebp
	vpor	xmm6,xmm6,xmm9
	mov	edi,eax
	xor	eax,ebx
	vmovdqa	xmm10,xmm6
	add	ecx,DWORD[40+rsp]
	and	edi,ebx
	and	esi,eax
	shrd	ebp,ebp,7
	add	ecx,edi
	mov	edi,edx
	shld	edx,edx,5
	add	ecx,esi
	xor	eax,ebx
	add	ecx,edx
	mov	esi,ebp
	xor	ebp,eax
	add	ebx,DWORD[44+rsp]
	and	esi,eax
	and	edi,ebp
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-48))+r15]
	shrd	edx,edx,7
	add	ebx,esi
	mov	esi,ecx
	shld	ecx,ecx,5
	add	ebx,edi
	xor	ebp,eax
	add	ebx,ecx
	vpalignr	xmm10,xmm6,xmm5,8
	vpxor	xmm7,xmm7,xmm3
	mov	edi,edx
	xor	edx,ebp
	add	eax,DWORD[48+rsp]
	and	edi,ebp
	vpxor	xmm7,xmm7,xmm0
	and	esi,edx
	shrd	ecx,ecx,7
	vmovdqa	xmm9,XMMWORD[48+r11]
	vpaddd	xmm8,xmm8,xmm6
	add	eax,edi
	mov	edi,ebx
	vpxor	xmm7,xmm7,xmm10
	shld	ebx,ebx,5
	add	eax,esi
	xor	edx,ebp
	add	eax,ebx
	vpsrld	xmm10,xmm7,30
	vmovdqa	XMMWORD[32+rsp],xmm8
	mov	esi,ecx
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-32))+r15]
	xor	ecx,edx
	add	ebp,DWORD[52+rsp]
	and	esi,edx
	vpslld	xmm7,xmm7,2
	and	edi,ecx
	shrd	ebx,ebx,7
	add	ebp,esi
	mov	esi,eax
	shld	eax,eax,5
	add	ebp,edi
	xor	ecx,edx
	add	ebp,eax
	vpor	xmm7,xmm7,xmm10
	mov	edi,ebx
	xor	ebx,ecx
	vmovdqa	xmm8,xmm7
	add	edx,DWORD[56+rsp]
	and	edi,ecx
	and	esi,ebx
	shrd	eax,eax,7
	add	edx,edi
	mov	edi,ebp
	shld	ebp,ebp,5
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-16))+r15]
	add	edx,esi
	xor	ebx,ecx
	add	edx,ebp
	mov	esi,eax
	xor	eax,ebx
	add	ecx,DWORD[60+rsp]
	and	esi,ebx
	and	edi,eax
	shrd	ebp,ebp,7
	add	ecx,esi
	mov	esi,edx
	shld	edx,edx,5
	add	ecx,edi
	xor	eax,ebx
	add	ecx,edx
	vpalignr	xmm8,xmm7,xmm6,8
	vpxor	xmm0,xmm0,xmm4
	mov	edi,ebp
	xor	ebp,eax
	add	ebx,DWORD[rsp]
	and	edi,eax
	vpxor	xmm0,xmm0,xmm1
	and	esi,ebp
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[r15]
	shrd	edx,edx,7
	vmovdqa	xmm10,xmm9
	vpaddd	xmm9,xmm9,xmm7
	add	ebx,edi
	mov	edi,ecx
	vpxor	xmm0,xmm0,xmm8
	shld	ecx,ecx,5
	add	ebx,esi
	xor	ebp,eax
	add	ebx,ecx
	vpsrld	xmm8,xmm0,30
	vmovdqa	XMMWORD[48+rsp],xmm9
	mov	esi,edx
	xor	edx,ebp
	add	eax,DWORD[4+rsp]
	and	esi,ebp
	vpslld	xmm0,xmm0,2
	and	edi,edx
	shrd	ecx,ecx,7
	add	eax,esi
	mov	esi,ebx
	shld	ebx,ebx,5
	add	eax,edi
	xor	edx,ebp
	add	eax,ebx
	vpor	xmm0,xmm0,xmm8
	mov	edi,ecx
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[16+r15]
	xor	ecx,edx
	vmovdqa	xmm9,xmm0
	add	ebp,DWORD[8+rsp]
	and	edi,edx
	and	esi,ecx
	shrd	ebx,ebx,7
	add	ebp,edi
	mov	edi,eax
	shld	eax,eax,5
	add	ebp,esi
	xor	ecx,edx
	add	ebp,eax
	mov	esi,ebx
	xor	ebx,ecx
	add	edx,DWORD[12+rsp]
	and	esi,ecx
	and	edi,ebx
	shrd	eax,eax,7
	add	edx,esi
	mov	esi,ebp
	shld	ebp,ebp,5
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[32+r15]
	add	edx,edi
	xor	ebx,ecx
	add	edx,ebp
	vpalignr	xmm9,xmm0,xmm7,8
	vpxor	xmm1,xmm1,xmm5
	mov	edi,eax
	xor	eax,ebx
	add	ecx,DWORD[16+rsp]
	and	edi,ebx
	vpxor	xmm1,xmm1,xmm2
	and	esi,eax
	shrd	ebp,ebp,7
	vmovdqa	xmm8,xmm10
	vpaddd	xmm10,xmm10,xmm0
	add	ecx,edi
	mov	edi,edx
	vpxor	xmm1,xmm1,xmm9
	shld	edx,edx,5
	add	ecx,esi
	xor	eax,ebx
	add	ecx,edx
	vpsrld	xmm9,xmm1,30
	vmovdqa	XMMWORD[rsp],xmm10
	mov	esi,ebp
	xor	ebp,eax
	add	ebx,DWORD[20+rsp]
	and	esi,eax
	vpslld	xmm1,xmm1,2
	and	edi,ebp
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[48+r15]
	shrd	edx,edx,7
	add	ebx,esi
	mov	esi,ecx
	shld	ecx,ecx,5
	add	ebx,edi
	xor	ebp,eax
	add	ebx,ecx
	vpor	xmm1,xmm1,xmm9
	mov	edi,edx
	xor	edx,ebp
	vmovdqa	xmm10,xmm1
	add	eax,DWORD[24+rsp]
	and	edi,ebp
	and	esi,edx
	shrd	ecx,ecx,7
	add	eax,edi
	mov	edi,ebx
	shld	ebx,ebx,5
	add	eax,esi
	xor	edx,ebp
	add	eax,ebx
	mov	esi,ecx
	cmp	r8d,11
	jb	NEAR $L$vaesenclast3
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[64+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[80+r15]
	je	NEAR $L$vaesenclast3
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[96+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[112+r15]
$L$vaesenclast3:
	vaesenclast	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((16-112))+r15]
	xor	ecx,edx
	add	ebp,DWORD[28+rsp]
	and	esi,edx
	and	edi,ecx
	shrd	ebx,ebx,7
	add	ebp,esi
	mov	esi,eax
	shld	eax,eax,5
	add	ebp,edi
	xor	ecx,edx
	add	ebp,eax
	vpalignr	xmm10,xmm1,xmm0,8
	vpxor	xmm2,xmm2,xmm6
	mov	edi,ebx
	xor	ebx,ecx
	add	edx,DWORD[32+rsp]
	and	edi,ecx
	vpxor	xmm2,xmm2,xmm3
	and	esi,ebx
	shrd	eax,eax,7
	vmovdqa	xmm9,xmm8
	vpaddd	xmm8,xmm8,xmm1
	add	edx,edi
	mov	edi,ebp
	vpxor	xmm2,xmm2,xmm10
	shld	ebp,ebp,5
	vmovups	xmm12,XMMWORD[48+r12]
	vxorps	xmm12,xmm12,xmm13
	vmovups	XMMWORD[32+r12*1+r13],xmm11
	vxorps	xmm11,xmm11,xmm12
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-80))+r15]
	add	edx,esi
	xor	ebx,ecx
	add	edx,ebp
	vpsrld	xmm10,xmm2,30
	vmovdqa	XMMWORD[16+rsp],xmm8
	mov	esi,eax
	xor	eax,ebx
	add	ecx,DWORD[36+rsp]
	and	esi,ebx
	vpslld	xmm2,xmm2,2
	and	edi,eax
	shrd	ebp,ebp,7
	add	ecx,esi
	mov	esi,edx
	shld	edx,edx,5
	add	ecx,edi
	xor	eax,ebx
	add	ecx,edx
	vpor	xmm2,xmm2,xmm10
	mov	edi,ebp
	xor	ebp,eax
	vmovdqa	xmm8,xmm2
	add	ebx,DWORD[40+rsp]
	and	edi,eax
	and	esi,ebp
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-64))+r15]
	shrd	edx,edx,7
	add	ebx,edi
	mov	edi,ecx
	shld	ecx,ecx,5
	add	ebx,esi
	xor	ebp,eax
	add	ebx,ecx
	mov	esi,edx
	xor	edx,ebp
	add	eax,DWORD[44+rsp]
	and	esi,ebp
	and	edi,edx
	shrd	ecx,ecx,7
	add	eax,esi
	mov	esi,ebx
	shld	ebx,ebx,5
	add	eax,edi
	xor	edx,ebp
	add	eax,ebx
	vpalignr	xmm8,xmm2,xmm1,8
	vpxor	xmm3,xmm3,xmm7
	add	ebp,DWORD[48+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-48))+r15]
	xor	esi,edx
	mov	edi,eax
	shld	eax,eax,5
	vpxor	xmm3,xmm3,xmm4
	xor	esi,ecx
	add	ebp,eax
	vmovdqa	xmm10,xmm9
	vpaddd	xmm9,xmm9,xmm2
	shrd	ebx,ebx,7
	add	ebp,esi
	vpxor	xmm3,xmm3,xmm8
	add	edx,DWORD[52+rsp]
	xor	edi,ecx
	mov	esi,ebp
	shld	ebp,ebp,5
	vpsrld	xmm8,xmm3,30
	vmovdqa	XMMWORD[32+rsp],xmm9
	xor	edi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,edi
	vpslld	xmm3,xmm3,2
	add	ecx,DWORD[56+rsp]
	xor	esi,ebx
	mov	edi,edx
	shld	edx,edx,5
	xor	esi,eax
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((-32))+r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,esi
	vpor	xmm3,xmm3,xmm8
	add	ebx,DWORD[60+rsp]
	xor	edi,eax
	mov	esi,ecx
	shld	ecx,ecx,5
	xor	edi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,edi
	add	eax,DWORD[rsp]
	vpaddd	xmm10,xmm10,xmm3
	xor	esi,ebp
	mov	edi,ebx
	shld	ebx,ebx,5
	xor	esi,edx
	movdqa	XMMWORD[48+rsp],xmm10
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,esi
	add	ebp,DWORD[4+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[((-16))+r15]
	xor	edi,edx
	mov	esi,eax
	shld	eax,eax,5
	xor	edi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,edi
	add	edx,DWORD[8+rsp]
	xor	esi,ecx
	mov	edi,ebp
	shld	ebp,ebp,5
	xor	esi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,esi
	add	ecx,DWORD[12+rsp]
	xor	edi,ebx
	mov	esi,edx
	shld	edx,edx,5
	xor	edi,eax
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,edi
	cmp	r10,r14
	je	NEAR $L$done_avx
	vmovdqa	xmm6,XMMWORD[64+r11]
	vmovdqa	xmm9,XMMWORD[r11]
	vmovdqu	xmm0,XMMWORD[r10]
	vmovdqu	xmm1,XMMWORD[16+r10]
	vmovdqu	xmm2,XMMWORD[32+r10]
	vmovdqu	xmm3,XMMWORD[48+r10]
	vpshufb	xmm0,xmm0,xmm6
	add	r10,64
	add	ebx,DWORD[16+rsp]
	xor	esi,eax
	vpshufb	xmm1,xmm1,xmm6
	mov	edi,ecx
	shld	ecx,ecx,5
	vpaddd	xmm4,xmm0,xmm9
	xor	esi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,esi
	vmovdqa	XMMWORD[rsp],xmm4
	add	eax,DWORD[20+rsp]
	xor	edi,ebp
	mov	esi,ebx
	shld	ebx,ebx,5
	xor	edi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,edi
	add	ebp,DWORD[24+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[16+r15]
	xor	esi,edx
	mov	edi,eax
	shld	eax,eax,5
	xor	esi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,esi
	add	edx,DWORD[28+rsp]
	xor	edi,ecx
	mov	esi,ebp
	shld	ebp,ebp,5
	xor	edi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,edi
	add	ecx,DWORD[32+rsp]
	xor	esi,ebx
	vpshufb	xmm2,xmm2,xmm6
	mov	edi,edx
	shld	edx,edx,5
	vpaddd	xmm5,xmm1,xmm9
	xor	esi,eax
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[32+r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,esi
	vmovdqa	XMMWORD[16+rsp],xmm5
	add	ebx,DWORD[36+rsp]
	xor	edi,eax
	mov	esi,ecx
	shld	ecx,ecx,5
	xor	edi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,edi
	add	eax,DWORD[40+rsp]
	xor	esi,ebp
	mov	edi,ebx
	shld	ebx,ebx,5
	xor	esi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,esi
	add	ebp,DWORD[44+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[48+r15]
	xor	edi,edx
	mov	esi,eax
	shld	eax,eax,5
	xor	edi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,edi
	add	edx,DWORD[48+rsp]
	xor	esi,ecx
	vpshufb	xmm3,xmm3,xmm6
	mov	edi,ebp
	shld	ebp,ebp,5
	vpaddd	xmm6,xmm2,xmm9
	xor	esi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,esi
	vmovdqa	XMMWORD[32+rsp],xmm6
	add	ecx,DWORD[52+rsp]
	xor	edi,ebx
	mov	esi,edx
	shld	edx,edx,5
	xor	edi,eax
	cmp	r8d,11
	jb	NEAR $L$vaesenclast4
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[64+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[80+r15]
	je	NEAR $L$vaesenclast4
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[96+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[112+r15]
$L$vaesenclast4:
	vaesenclast	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((16-112))+r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,edi
	add	ebx,DWORD[56+rsp]
	xor	esi,eax
	mov	edi,ecx
	shld	ecx,ecx,5
	xor	esi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,esi
	add	eax,DWORD[60+rsp]
	xor	edi,ebp
	mov	esi,ebx
	shld	ebx,ebx,5
	xor	edi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,edi
	vmovups	XMMWORD[48+r12*1+r13],xmm11
	lea	r12,[64+r12]

	add	eax,DWORD[r9]
	add	esi,DWORD[4+r9]
	add	ecx,DWORD[8+r9]
	add	edx,DWORD[12+r9]
	mov	DWORD[r9],eax
	add	ebp,DWORD[16+r9]
	mov	DWORD[4+r9],esi
	mov	ebx,esi
	mov	DWORD[8+r9],ecx
	mov	DWORD[12+r9],edx
	mov	DWORD[16+r9],ebp
	jmp	NEAR $L$oop_avx

ALIGN	16
$L$done_avx:
	add	ebx,DWORD[16+rsp]
	xor	esi,eax
	mov	edi,ecx
	shld	ecx,ecx,5
	xor	esi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,esi
	add	eax,DWORD[20+rsp]
	xor	edi,ebp
	mov	esi,ebx
	shld	ebx,ebx,5
	xor	edi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,edi
	add	ebp,DWORD[24+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[16+r15]
	xor	esi,edx
	mov	edi,eax
	shld	eax,eax,5
	xor	esi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,esi
	add	edx,DWORD[28+rsp]
	xor	edi,ecx
	mov	esi,ebp
	shld	ebp,ebp,5
	xor	edi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,edi
	add	ecx,DWORD[32+rsp]
	xor	esi,ebx
	mov	edi,edx
	shld	edx,edx,5
	xor	esi,eax
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[32+r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,esi
	add	ebx,DWORD[36+rsp]
	xor	edi,eax
	mov	esi,ecx
	shld	ecx,ecx,5
	xor	edi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,edi
	add	eax,DWORD[40+rsp]
	xor	esi,ebp
	mov	edi,ebx
	shld	ebx,ebx,5
	xor	esi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,esi
	add	ebp,DWORD[44+rsp]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[48+r15]
	xor	edi,edx
	mov	esi,eax
	shld	eax,eax,5
	xor	edi,ecx
	add	ebp,eax
	shrd	ebx,ebx,7
	add	ebp,edi
	add	edx,DWORD[48+rsp]
	xor	esi,ecx
	mov	edi,ebp
	shld	ebp,ebp,5
	xor	esi,ebx
	add	edx,ebp
	shrd	eax,eax,7
	add	edx,esi
	add	ecx,DWORD[52+rsp]
	xor	edi,ebx
	mov	esi,edx
	shld	edx,edx,5
	xor	edi,eax
	cmp	r8d,11
	jb	NEAR $L$vaesenclast5
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[64+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[80+r15]
	je	NEAR $L$vaesenclast5
	vaesenc	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[96+r15]
	vaesenc	xmm11,xmm11,xmm14
	vmovups	xmm15,XMMWORD[112+r15]
$L$vaesenclast5:
	vaesenclast	xmm11,xmm11,xmm15
	vmovups	xmm14,XMMWORD[((16-112))+r15]
	add	ecx,edx
	shrd	ebp,ebp,7
	add	ecx,edi
	add	ebx,DWORD[56+rsp]
	xor	esi,eax
	mov	edi,ecx
	shld	ecx,ecx,5
	xor	esi,ebp
	add	ebx,ecx
	shrd	edx,edx,7
	add	ebx,esi
	add	eax,DWORD[60+rsp]
	xor	edi,ebp
	mov	esi,ebx
	shld	ebx,ebx,5
	xor	edi,edx
	add	eax,ebx
	shrd	ecx,ecx,7
	add	eax,edi
	vmovups	XMMWORD[48+r12*1+r13],xmm11
	mov	r8,QWORD[88+rsp]

	add	eax,DWORD[r9]
	add	esi,DWORD[4+r9]
	add	ecx,DWORD[8+r9]
	mov	DWORD[r9],eax
	add	edx,DWORD[12+r9]
	mov	DWORD[4+r9],esi
	add	ebp,DWORD[16+r9]
	mov	DWORD[8+r9],ecx
	mov	DWORD[12+r9],edx
	mov	DWORD[16+r9],ebp
	vmovups	XMMWORD[r8],xmm11
	vzeroall
	movaps	xmm6,XMMWORD[((96+0))+rsp]
	movaps	xmm7,XMMWORD[((96+16))+rsp]
	movaps	xmm8,XMMWORD[((96+32))+rsp]
	movaps	xmm9,XMMWORD[((96+48))+rsp]
	movaps	xmm10,XMMWORD[((96+64))+rsp]
	movaps	xmm11,XMMWORD[((96+80))+rsp]
	movaps	xmm12,XMMWORD[((96+96))+rsp]
	movaps	xmm13,XMMWORD[((96+112))+rsp]
	movaps	xmm14,XMMWORD[((96+128))+rsp]
	movaps	xmm15,XMMWORD[((96+144))+rsp]
	lea	rsi,[264+rsp]
	mov	r15,QWORD[rsi]
	mov	r14,QWORD[8+rsi]
	mov	r13,QWORD[16+rsi]
	mov	r12,QWORD[24+rsi]
	mov	rbp,QWORD[32+rsi]
	mov	rbx,QWORD[40+rsi]
	lea	rsp,[48+rsi]
$L$epilogue_avx:
	mov	rdi,QWORD[8+rsp]	;WIN64 epilogue
	mov	rsi,QWORD[16+rsp]
	DB	0F3h,0C3h		;repret
$L$SEH_end_aesni_cbc_sha1_enc_avx:
ALIGN	64
K_XX_XX:
	DD	0x5a827999,0x5a827999,0x5a827999,0x5a827999	
	DD	0x6ed9eba1,0x6ed9eba1,0x6ed9eba1,0x6ed9eba1	
	DD	0x8f1bbcdc,0x8f1bbcdc,0x8f1bbcdc,0x8f1bbcdc	
	DD	0xca62c1d6,0xca62c1d6,0xca62c1d6,0xca62c1d6	
	DD	0x00010203,0x04050607,0x08090a0b,0x0c0d0e0f	

DB	65,69,83,78,73,45,67,66,67,43,83,72,65,49,32,115
DB	116,105,116,99,104,32,102,111,114,32,120,56,54,95,54,52
DB	44,32,67,82,89,80,84,79,71,65,77,83,32,98,121,32
DB	60,97,112,112,114,111,64,111,112,101,110,115,115,108,46,111
DB	114,103,62,0
ALIGN	64
EXTERN	__imp_RtlVirtualUnwind

ALIGN	16
ssse3_handler:
	push	rsi
	push	rdi
	push	rbx
	push	rbp
	push	r12
	push	r13
	push	r14
	push	r15
	pushfq
	sub	rsp,64

	mov	rax,QWORD[120+r8]
	mov	rbx,QWORD[248+r8]

	mov	rsi,QWORD[8+r9]
	mov	r11,QWORD[56+r9]

	mov	r10d,DWORD[r11]
	lea	r10,[r10*1+rsi]
	cmp	rbx,r10
	jb	NEAR $L$common_seh_tail

	mov	rax,QWORD[152+r8]

	mov	r10d,DWORD[4+r11]
	lea	r10,[r10*1+rsi]
	cmp	rbx,r10
	jae	NEAR $L$common_seh_tail

	lea	rsi,[96+rax]
	lea	rdi,[512+r8]
	mov	ecx,20
	DD	0xa548f3fc		
	lea	rax,[264+rax]

	mov	r15,QWORD[rax]
	mov	r14,QWORD[8+rax]
	mov	r13,QWORD[16+rax]
	mov	r12,QWORD[24+rax]
	mov	rbp,QWORD[32+rax]
	mov	rbx,QWORD[40+rax]
	lea	rax,[48+rax]
	mov	QWORD[144+r8],rbx
	mov	QWORD[160+r8],rbp
	mov	QWORD[216+r8],r12
	mov	QWORD[224+r8],r13
	mov	QWORD[232+r8],r14
	mov	QWORD[240+r8],r15

$L$common_seh_tail:
	mov	rdi,QWORD[8+rax]
	mov	rsi,QWORD[16+rax]
	mov	QWORD[152+r8],rax
	mov	QWORD[168+r8],rsi
	mov	QWORD[176+r8],rdi

	mov	rdi,QWORD[40+r9]
	mov	rsi,r8
	mov	ecx,154
	DD	0xa548f3fc		

	mov	rsi,r9
	xor	rcx,rcx
	mov	rdx,QWORD[8+rsi]
	mov	r8,QWORD[rsi]
	mov	r9,QWORD[16+rsi]
	mov	r10,QWORD[40+rsi]
	lea	r11,[56+rsi]
	lea	r12,[24+rsi]
	mov	QWORD[32+rsp],r10
	mov	QWORD[40+rsp],r11
	mov	QWORD[48+rsp],r12
	mov	QWORD[56+rsp],rcx
	call	QWORD[__imp_RtlVirtualUnwind]

	mov	eax,1
	add	rsp,64
	popfq
	pop	r15
	pop	r14
	pop	r13
	pop	r12
	pop	rbp
	pop	rbx
	pop	rdi
	pop	rsi
	DB	0F3h,0C3h		;repret


section	.pdata rdata align=4
ALIGN	4
	DD	$L$SEH_begin_aesni_cbc_sha1_enc_ssse3 wrt ..imagebase
	DD	$L$SEH_end_aesni_cbc_sha1_enc_ssse3 wrt ..imagebase
	DD	$L$SEH_info_aesni_cbc_sha1_enc_ssse3 wrt ..imagebase
	DD	$L$SEH_begin_aesni_cbc_sha1_enc_avx wrt ..imagebase
	DD	$L$SEH_end_aesni_cbc_sha1_enc_avx wrt ..imagebase
	DD	$L$SEH_info_aesni_cbc_sha1_enc_avx wrt ..imagebase
section	.xdata rdata align=8
ALIGN	8
$L$SEH_info_aesni_cbc_sha1_enc_ssse3:
DB	9,0,0,0
	DD	ssse3_handler wrt ..imagebase
	DD	$L$prologue_ssse3 wrt ..imagebase,$L$epilogue_ssse3 wrt ..imagebase	
$L$SEH_info_aesni_cbc_sha1_enc_avx:
DB	9,0,0,0
	DD	ssse3_handler wrt ..imagebase
	DD	$L$prologue_avx wrt ..imagebase,$L$epilogue_avx wrt ..imagebase		
